//
//  ViewController.m
//  faceShare
//
//  Created by Tuna Başaran on 10/18/12.
//  Copyright (c) 2012 Anıl Oruç. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

@synthesize loginBtn = _loginBtn;
@synthesize profilLabel = _profilLabel;
@synthesize profilPic = _profilPic;
@synthesize publishButton = _publishButton;
@synthesize logoutBtn = _logoutBtn;
@synthesize request = _request;
@synthesize textField = _textField;

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    //loginBtn.frame = CGRectMake(150.0f, 150.0f, 151.0f, 43.0f);
    
    
    //DynamicLabel * dlabel = [[DynamicLabel alloc] initWithFrame:CGRectMake(30, 130, 300, 20)];
    
    temp = true;
    
    self.textField.hidden = YES;
    self.publishButton.hidden = YES;
    self.logoutBtn.hidden = YES;
    
    self.profilLabel = [[UILabel alloc]initWithFrame:CGRectMake(104.0f, 17.0f, 210.0f, 21.0f)];
    self.profilPic = [[FBProfilePictureView alloc]initWithFrame:CGRectMake(20.0f, 17.0f, 75.0f, 75.0f)];
    
    [self.view addSubview:self.profilLabel];
    [self.view addSubview:self.profilPic];
    
    self.profilLabel.text = @"";
    self.profilLabel.backgroundColor = [UIColor clearColor];
    
    [self.loginBtn setImage:[UIImage imageNamed:@"login-button-small.png"] forState:UIControlStateNormal];
    [self.loginBtn setTitle:@"Login" forState:UIControlStateNormal];
    self.loginBtn.adjustsImageWhenHighlighted = YES;
    self.loginBtn.titleLabel.textColor = [UIColor whiteColor];
    //self.loginBtn.titleLabel.textAlignment = UITextAlignmentCenter;
    self.loginBtn.titleLabel.font = [UIFont fontWithName: @"Helvetica" size: 14];
    [self.view addSubview:self.loginBtn];
    [self.view addSubview:self.publishButton];
    
    //loginBtn.imageView.image = [UIImage imageNamed:@"login-button-small.png"];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)loginButton:(id)sender {
    
    AppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
    
    
    
    [appDelegate openSessionWithAllowLoginUI:YES] ? [self populateUserDetails]: nil ;
    [self.textField resignFirstResponder];
    
    
    if (temp) {
        self.loginBtn.titleLabel.text = @"Logout";
        temp = false;

    }
    else{
        temp = true;
        self.loginBtn.titleLabel.text = @"Login";
    }
}

- (IBAction)publish :(id)sender
{
    [self postPhotoThenOpenGraphAction];
    NSLog(@"Resim Gönderildi.");
}

- (IBAction)logout :(id)sender
{
    if (![self.textField.text isEqualToString:@""]) {
        [self postTextThenOpenGraphAction:self.textField.text];
        NSLog(@"Yazı Gönderildi.");
    }
    else
    {
        UIAlertView *alertView = [[UIAlertView alloc]
                                  initWithTitle:@"Facebook Share"
                                  message:@"Lütfen paylaşılcak alanı boş bırakmayınız."
                                  delegate:nil
                                  cancelButtonTitle:@"OK"
                                  otherButtonTitles:nil];
        [alertView show];
    }    
}

- (void)populateUserDetails
{
    if (FBSession.activeSession.isOpen) {
        [[FBRequest requestForMe] startWithCompletionHandler:
         ^(FBRequestConnection *connection,
           NSDictionary<FBGraphUser> *user,
           NSError *error) {
             if (!error) {
                 NSLog(@"Location: %@",user.location);
                 NSLog(@"Link: %@",user.link);
                 NSLog(@"Name: %@",user.name);
                 NSLog(@"Birthday: %@",user.birthday);
                 NSLog(@"First Name: %@",user.first_name);
                 NSLog(@"Middle Name: %@",user.middle_name);
                 NSLog(@"Last Name: %@",user.last_name);
                 NSLog(@"ID: %@",user.id);
                 NSLog(@"UserName: %@",user.username);
                 
                 self.profilLabel.text = user.name;
                 self.profilPic.profileID = user.id;
             }
         }];
        self.textField.hidden = NO;
        self.logoutBtn.hidden = NO;
        self.publishButton.hidden = NO;
        
        
        
        [self.loginBtn setTitle:@"Logout" forState:UIControlStateNormal];
        
        NSLog(@"%@", self.loginBtn.titleLabel.text);
    }
    else {
        self.textField.hidden = YES;
        self.logoutBtn.hidden = YES;
        self.publishButton.hidden = YES;
        
        [self.loginBtn setTitle:@"Login" forState:UIControlStateDisabled];
    }
}

-(void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
    
    if (FBSession.activeSession.isOpen) {
        [self populateUserDetails];
    }
}

- (void)sessionStateChanged:(NSNotification*)notification {
    if (FBSession.activeSession.isOpen) {
        self.textField.hidden = NO;
        self.logoutBtn.hidden = NO;
        self.publishButton.hidden = NO;
        [self.loginBtn setTitle:@"Logout" forState:UIControlStateNormal];
        
    } else {
        self.textField.hidden = YES;
        self.logoutBtn.hidden = YES;
        self.publishButton.hidden = YES;
        [self.loginBtn setTitle:@"Login" forState:UIControlStateNormal];
    }
}

- (void)postTextThenOpenGraphAction:(NSString *)yazi
{
    FBRequestConnection *connection = [[FBRequestConnection alloc] init];
    
    FBRequest *request3 = [FBRequest requestForPostStatusUpdate:yazi];
    
    [connection addRequest:request3
         completionHandler:
     ^(FBRequestConnection *connection, id result, NSError *error) {
         if (!error) {
         }
     }
            batchEntryName:@"textpost"
     ];
    FBRequest *request2 = [FBRequest
                           requestForGraphPath:@"{result=textpost:$.id}"];
    [connection addRequest:request2
         completionHandler:
     ^(FBRequestConnection *connection, id result, NSError *error) {
         if (!error &&
             result) {
             NSString *source = [result objectForKey:@"source"];
             NSLog(@"%@",source);
             //[self postOpenGraphActionWithPhotoURL:source];
         }
     }
     ];
    
    [connection start];
}

- (void)postPhotoThenOpenGraphAction {
    FBRequestConnection *connection = [[FBRequestConnection alloc] init];
    
    FBRequest *request1 = [FBRequest requestForUploadPhoto:[UIImage imageNamed:@"index.png"]];
    
    [connection addRequest:request1
         completionHandler:
     ^(FBRequestConnection *connection, id result, NSError *error) {
         if (!error) {
         }
     }
            batchEntryName:@"photopost"
     ];
    
    FBRequest *request2 = [FBRequest
                           requestForGraphPath:@"{result=photopost:$.id}"];
    [connection addRequest:request2
         completionHandler:
     ^(FBRequestConnection *connection, id result, NSError *error) {
         if (!error &&
             result) {
             NSString *source = [result objectForKey:@"source"];
             NSLog(@"%@",source);
             //[self postOpenGraphActionWithPhotoURL:source];
         }
     }
     ];
    
    [connection start];
}



@end
